<?php
namespace ID3\Aliquando\Modules\Elementor;


if(!class_exists('\ID3\Aliquando\Modules\Elementor\Module')){

    

    class Module extends \ID3\Bases\Module{

        public $_module_path = ELEMENTOR_MODULE_PATH;

        public $form_context = null;

        function __construct(){
            //add_action( 'admin_enqueue_scripts', [$this, 'loadAdminResources']);
            //if(class_exists('ElementorPro')){
                if(class_exists('ElementorPro\Modules\Forms\Classes\Ajax_Handler')){
                    if(\ElementorPro\Modules\Forms\Classes\Ajax_Handler::is_form_submitted()){
                        $this->handleFormPost();
                    }
                }
            //}
        }

        static function dummyContent($path){
            $filePath = ELEMENTOR_MODULE_PATH . '/dummies/' . $path;
            if(file_exists($filePath)){
        
                $pathParts = explode('/', $path);
        
                $partClasses = ['si-part'];
                $partClasses[] = 'si-part-' . str_replace(['.php','_'],['','-'],$pathParts[1]);
        
                echo('<div class="' . implode(' ',$partClasses) .'">');
                include $filePath;
                echo('</div>');
            }
            
        }


        function includes(){
            //include ELEMENTOR_MODULE_PATH . '/widgets/searchbox.php';
        }

        function register_actions(){
            //add_action( 'elementor/frontend/after_register_scripts',[$this, 'loadAdminResources'] );
            
            add_action( 'elementor/editor/before_enqueue_scripts', [$this, 'loadAdminResources'] );
            add_action( 'elementor_pro/init', [$this, 'registerFormActions']);
            add_action( 'elementor/elements/categories_registered', array($this, 'addWidgetCategory'));
            add_action( 'elementor/dynamic_tags/register_tags', array($this, 'registerDynamicTags'));
            add_action( 'elementor/widgets/widgets_registered',  array($this, 'registerWidgets'));
            add_action( 'elementor/elements/elements_registered',  array($this, 'registerElements'));   

            add_filter( 'elementor_pro/forms/record/actions_before', array($this, 'formPreprocess'), 1,2);

            //parent::register_actions();
        }

        function handleFormPost(){
            if(get_current_blog_id() === 1) return;

            $post_id = $_POST['post_id'];
            $post = get_post($post_id);
            if($post !== false && $post->post_type == 'elementor_library'){
                //var_dump($post);
                return;
            }
            

            $this->form_context = [
                'admin_email' => get_option( 'admin_email' ),
                /* translators: %s: Site title. */
                //'email_subject' => sprintf( __( 'New message from "%s"', 'elementor-pro' ), get_bloginfo( 'name' ) ),
                //'email_content' => '[all-fields]',
                'site_title' => get_bloginfo( 'name' ),
                'site_domain' => str_ireplace( 'www.', '', parse_url( home_url(), PHP_URL_HOST ) )
                //'email_from' => get_bloginfo( 'admin_email' ),
                //'email_reply_to' => 'noreply@' . Utils::get_site_domain(),
                //'email_to_cc' => '',
                //'email_to_bcc' => '',
            ];

            switch_to_blog(1);

        }

        function loadAdminResources(){
            //wp_enqueue_script( 'aliquando-elementor-editor-script', plugins_url('/elementor/scripts.min.js', ELEMENTOR_MODULE_PATH) );
            // wp_enqueue_script( 'framework-public-script', plugins_url('/scripts/public.min.js', \ID3\Framework\PLUGIN) );
            // wp_enqueue_script( 'aliquando-public-script', plugins_url('/scripts/public.min.js', \ID3\Aliquando\PLUGIN) );
        }

        function register_filters(){
            // add_filter( 'si/page_builder/get_page_template', function( $page_template ) {
            //     //echo($page_template);
            //     if(strpos($page_template,'elementor_') !== false){
            //         $newPageTemplate = str_replace(['elementor_','_'],['','-'],$page_template);
            //         $page_template = \ELEMENTOR_PATH . 'modules/page-templates/templates/' . $newPageTemplate . '.php';
            //     }
            //     return $page_template;
            // } );
        }
        
        // function get_script_depends(){
        //     //if(!isset($_GET['elementor-preview'])) return [];

        //     return [ 
        //         [ 'elementor-editor-script', plugins_url('/elementor/scripts.min.js', ELEMENTOR_MODULE_PATH)] 
        //     ];
        // }

        // function get_style_depends(){
        //     //if(!isset($_GET['elementor-preview'])) return [];

        //     return [ 
        //         [ 'elementor-editor-style', plugins_url('/elementor/assets/elementor-styles.min.css', ELEMENTOR_MODULE_PATH)] 
        //     ];
        // }

        function addWidgetCategory($elements_manager){
            $elements_manager->add_category(
                'aliquando',
                [
                    'title' => 'Aliquando',
                    'icon' => 'fa fa-plug',
                ]
            );
        }

        function registerWidgets() {

            $widgets = [
                //'network_content' => '\NetworkContentWidget',
                'network_template' => '\NetworkTemplateWidget',
                'office_info' => '\OfficeInfoWidget',
                'social_medias' => '\SocialMediasWidget'
            ];

            foreach ($widgets as $key => $instanceName) {
                // Include Widget files
                require_once(ELEMENTOR_MODULE_PATH . '/widgets/' . $key . '.php' );
                $fullyQualifiedInstanceName = 'ID3\Aliquando\Modules\Elementor' . $instanceName;
                // Register widget
                if(class_exists($fullyQualifiedInstanceName)){
                    
                    $widgetInstance =  new $fullyQualifiedInstanceName();
                    $widgetInstance->setModule($this);
        
                    \Elementor\Plugin::instance()->widgets_manager->register_widget_type($widgetInstance);
                }            
            }
            
        }

        function registerElements() {
            
        }

        function registerFormActions(){

            require_once 'classes/class.form-action.php';

            \ElementorPro\Plugin::instance()->modules_manager->get_modules( 'forms' )->add_form_action( 'id3-aliquando', new Aliquando_From_Action() );
        }


        function registerDynamicTags($dynamic_tags){
            // $dynTags = [
            //     //'listing_data' => 'SourceImmoListingDataTags',
            //     //'broker_data' => 'SourceImmoBrokerDataTags',
            //     'counter' => 'SourceImmoCounterTags',
            //     'single_data' => 'SourceImmoSingleDataTags',
            //     'single_data_container' => 'SourceImmoSingleDataContainerTags',
            //     'list_meta' => 'SourceImmoListMetaTags'
            // ];

            // foreach ($dynTags as $key => $instanceName) {
            //     // Include Widget files
            //     require_once(ELEMENTOR_MODULE_PATH . '/dynamic-tags/' . $key . '.php' );
            //     // Register widget
            //     $dynamic_tags->register_tag($instanceName);
            // }
        }

        public function get_template_list(){

        }

        public function get_page_list(){
            //$settings = $this->getSettings();

            switch_to_blog(1);
            
            // query
            $posts = new \WP_Query( array(
                'post_type' => 'page',
                'posts_per_page' => -1,
                'post_status' => 'publish',
                'sort_order' => 'asc',
                'sort_column' => 'post_title',
                'hierarchical' => 1,
                'suppress_filters' => false
            ) );

            $pages = $posts->posts;
            $lResult = array();
            foreach ($pages as &$page) {
                $lResult[$page->ID] = $page->post_title;
            }
            
            restore_current_blog();
            return $lResult;
        }

        public function get_elementor_content_list(){
            //$settings = $this->getSettings();

            switch_to_blog(1);
            
            // query
            $posts = new \WP_Query( array(
                'post_type' => 'elementor_library',
                'posts_per_page' => -1,
                'post_status' => 'publish',
                'sort_order' => 'asc',
                'sort_column' => 'post_title',
                'hierarchical' => 1,
                'suppress_filters' => false
            ) );

            $elements = $posts->posts;
            $lResult = array();
            foreach ($elements as $item) {
                $lResult[$item->ID] = $item->post_title;
            }
            
            restore_current_blog();
            return $lResult;
        }

        public function formPreprocess ( $record, $ajax_handler ) {
            
            try {
                $recordReflection = new \ReflectionClass($record);
            
                $formSettingsProp = $recordReflection->getProperty('form_settings');
                $formSettingsProp->setAccessible(true);
                $formSettings = $formSettingsProp->getValue($record);
                // Email or Email2 form action
                if(isset($formSettings['email_to'])){
                    $formSettings['email_to'] = str_replace('{{admin_email}}', $this->form_context['admin_email'], $formSettings['email_to']);
                    $formSettings['email_from'] = str_replace(['{{admin_email}}','{{site_domain}}'], [$this->form_context['admin_email'], $this->form_context['site_domain']], $formSettings['email_from']);
                    
                    $formSettings['email_subject'] = str_replace('{{site_title}}', $this->form_context['site_title'], $formSettings['email_subject']);
                    $formSettings['email_from_name'] = str_replace('{{site_title}}', $this->form_context['site_title'], $formSettings['email_from_name']);
                }


                $formSettingsProp->setValue($record,$formSettings);

            } catch (\Throwable $th) {
            //  var_dump($th);
            }

            return $record;
        }
    }
    $this->registerModule(new Module);

}

