<?php
namespace ID3\Aliquando\Modules\Elementor;

class NetworkContentWidget extends \Elementor\Widget_Base {

    private $_module = null;
    
    public function setModule($module){
        $this->_module = $module;
    }

	public function get_name() {
        return 'ali_network_content';
    }

	public function get_title() {
        return __('Network content', \ID3\Aliquando\TDOM);
    }

	public function get_icon() {
        return 'eicon-time-line';
    }

	public function get_categories() {
        return ['aliquando'];
    }

	protected function _register_controls() {

        
        $this->start_controls_section(
			'content_section',
			[
				'label' => __( 'Content'),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
        );

        if($this->_module != null){
            $page_list = $this->_module->get_page_list();
        }
        else{
            $page_list = [];
        }
        
        
		$this->add_control(
			'content_id',
			[
				'label' => __( 'Content', \ID3\Aliquando\TDOM),
				'type' => \Elementor\Controls_Manager::SELECT,
                'placeholder' => '',
                'options' => $page_list,
                'default' => ''
			]
        );

        
		$this->end_controls_section();
    }

    

    /**
	 * Render shortcode widget output on the frontend.
	 *
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since 1.0.0
	 * @access protected
	 */
	protected function render() {
        
        $settings = $this->get_settings();
        
        $content_id = $settings['content_id'];
        
        $shortcode_attrs = [];
        if( $content_id != ''){
            $shortcode_attrs[] = 'id="' .  $content_id . '"';
        }

        $shortcodeName = 'id3_aliquando_network_content';
        $shortcode = do_shortcode( shortcode_unautop('[' . $shortcodeName . ' ' . implode(' ', $shortcode_attrs) . ']' ));
		
        echo( $shortcode );
    }

	

}