<?php
namespace ID3\Aliquando\Modules\Elementor;
class NetworkTemplateWidget extends \Elementor\Widget_Base {

    private $_module = null;

    public function setModule($module){
        $this->_module = $module;
    }

	public function get_name() {
        return 'ali_network_template';
    }

	public function get_title() {
        return __('Network template', \ID3\Aliquando\TDOM);
    }

	public function get_icon() {
        return 'eicon-thumbnails-down';
    }

	public function get_categories() {
        return ['aliquando'];
    }

	protected function _register_controls() {

        
        $this->start_controls_section(
			'content_section',
			[
				'label' => __( 'Content'),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
        );
        

        if($this->_module != null){
            $template_list = $this->_module->get_elementor_content_list();
        }
        else{
            $template_list = [];
        }

		$this->add_control(
			'content_id',
			[
				'label' => __( 'Content', \ID3\Aliquando\TDOM),
				'type' => \Elementor\Controls_Manager::SELECT,
                'placeholder' => '',
                'options' => $template_list,
                'default' => ''
			]
        );

        
        // $this->add_control(
		// 	'import_btn',
		// 	[
		// 		'label' => __( 'Import locally', \ID3\Aliquando\TDOM),
        //         'text' => __( 'Import', \ID3\Aliquando\TDOM),
		// 		'type' => \Elementor\Controls_Manager::BUTTON,
        //         'event' => 'aliquando:importContent'
		// 	]
        // );
        
		$this->end_controls_section();
    }

    

    /**
	 * Render shortcode widget output on the frontend.
	 *
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since 1.0.0
	 * @access protected
	 */
	protected function render() {
        
        $settings = $this->get_settings();

        $content_id = $settings['content_id'];
        
        $shortcode_attrs = [];
        if( $content_id != ''){
            $shortcode_attrs[] = 'id="' .  $content_id . '"';
        }

        $shortcodeName = 'id3_aliquando_network_elementor_template';
        $shortcode = do_shortcode( shortcode_unautop('[' . $shortcodeName . ' ' . implode(' ', $shortcode_attrs) . ']' ));
        
		echo( $shortcode );
    }

	

}