id3Plugin
.controller('colorPaletteCtrl', function($scope, $rootScope){
    $scope.palettes = Array.from({length:9}, ($e,$i) => ($i+1) * 100);

    $scope.dialogOptions.actions = [
            {label: 'OK', primary: true, 
                action: function(){ 
                    console.log('colorPaletteCtrl/OK', $scope.model);
                    $scope.closeAndReturn($scope.model); 
                } 
            },
            {label: 'Cancel', 
                action: function(){ 
                    console.log('colorPaletteCtrl/Cancel');
                    $scope.cancel(); 
                } 
            }
        ];

    $scope.init = function($params){
        $scope.model = $params;
        if(id3IsNullOrEmpty($scope.model)){
            $scope.model = {}
        }

        console.log('colorPaletteCtrl/init', $params);
    }

});


id3Plugin
.controller('socialMediaCtrl', function($scope, $rootScope){

    $scope.dialogOptions.actions = [
        {label: 'OK', primary: true, 
            action: function(){ 
                console.log('socialMediaCtrl/OK', $scope.model);
                $scope.closeAndReturn($scope.model);
            } 
        }
    ];

    $scope.init = function($params){
        $scope.model = $params;
        if(id3IsNullOrEmpty($scope.model)){
            $scope.model = {
                type: 'facebook',
                url: ''
            }
        }
        console.log('socialMediaCtrl/init', $params);
    }

});


id3Plugin
.controller('codeFragmentCtrl', function($scope, $rootScope){
    $scope.dialogOptions.actions = [
        {label: 'OK', primary: true, 
            action: function(){ 
                $scope.closeAndReturn($scope.model); 
            } 
        },
        {label: 'Cancel', 
            action: function(){ 
                $scope.cancel(); 
            } 
        }
    ];

    $scope.model = null;
    
    $scope.init = function($params){
        $scope.model = $params;
        
        if(id3IsNullOrEmpty($scope.model)){
            $scope.model = {
                part: 'body:start',
                code_language: 'html',
                code: '',
                action_name:'',
                conditions:[]
            }
        }

    }

    $scope.addCondition = function(){
        $scope.model.conditions.push({type: 'locale', operator: 'equal', value: 'fr'});
    }

    $scope.removeCondition = function($index){
        $scope.model.conditions.splice($index,1);
    }
});

id3Plugin
.controller('licenseCtrl', function($scope, $rootScope, $id3Lists){
    $scope.dialogOptions.actions = [
        {label: 'OK', primary: true, 
            action: function(){ 
                $scope.closeAndReturn($scope.model); 
            } 
        },
        {label: 'Cancel', 
            action: function(){ 
                $scope.cancel(); 
            } 
        }
    ];

    $scope.model = null;
    $scope.licenseTypes = [];

    $scope.init = function($params){
        console.log('licenseCtrl/init',$params);

        $scope.networkLicenses = angular.copy($params.networkLicenses);
        delete $params.networkLicenses;
        $scope.model = $params;
        console.log('licenseCtrl/init',$params, $scope.networkLicenses);

        if(id3IsNullOrEmpty($scope.model)){
            $scope.model = {
                key: $id3Lists.get('licenseTypes').first().key
            };
        }
    }

    $scope.isOverridable = function(){
        if($scope.networkLicenses== undefined) return true;
        
        const lNetwork = $scope.networkLicenses.find($nl => $nl.key == $scope.model.key);
        if(lNetwork != null){
            if(!lNetwork.overridable){
                return false;
            }
        }
        return true;
    }
    
    $scope.addCondition = function(){
        $scope.model.conditions.push({type: 'locale', operator: 'equal', value: 'fr'});
    }

    $scope.removeCondition = function($index){
        $scope.model.conditions.splice($index,1);
    }
});


id3Plugin
.controller('sitePostCreationCtrl', function($scope, $rootScope){
    $scope.model = null;

    $scope.dialogOptions.actions = [
        {label: 'Continue', primary: true,
            action: function(){ 
                $scope.closeAndReturn(null); 
            } 
        }
    ];

    $scope.init = function($params){
        $scope.model = $params
    }

    $scope.openSite = function(){
        window.open('//' + $scope.model.domain); 
    }

    $scope.openDashboard = function(){
        window.open('//' + $scope.model.domain + '/wp-admin/'); 
    }
});


id3Plugin
.controller('networkLicenseCtrl', function($scope, $rootScope, $id3Lists){
    
    $scope.model = {};

    $scope.dialogOptions.actions = [
        {label: 'OK', primary: true, 
            action: function(){ 
                $scope.closeAndReturn($scope.prepareModel()); 
            } 
        },
        {label: 'Cancel', 
            action: function(){ 
                $scope.cancel(); 
            } 
        }
    ];


    $scope.init = function($params){
        $scope.model = $params;
    }

    $scope.prepareModel = function(){
        
        //$scope.model.label = $id3Lists.get('licenseTypes').find($l => $l.key == $scope.model.key).label;

        return $scope.model;
    }
})